/* ***********************************************************
 * This file was automatically generated on 2012-10-12.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling Stacks and four Bricklets
	/// </summary>
	public class BrickMaster : Device 
	{
		private static byte FUNCTION_GET_STACK_VOLTAGE = 1;
		private static byte FUNCTION_GET_STACK_CURRENT = 2;
		private static byte FUNCTION_SET_EXTENSION_TYPE = 3;
		private static byte FUNCTION_GET_EXTENSION_TYPE = 4;
		private static byte FUNCTION_IS_CHIBI_PRESENT = 5;
		private static byte FUNCTION_SET_CHIBI_ADDRESS = 6;
		private static byte FUNCTION_GET_CHIBI_ADDRESS = 7;
		private static byte FUNCTION_SET_CHIBI_MASTER_ADDRESS = 8;
		private static byte FUNCTION_GET_CHIBI_MASTER_ADDRESS = 9;
		private static byte FUNCTION_SET_CHIBI_SLAVE_ADDRESS = 10;
		private static byte FUNCTION_GET_CHIBI_SLAVE_ADDRESS = 11;
		private static byte FUNCTION_GET_CHIBI_SIGNAL_STRENGTH = 12;
		private static byte FUNCTION_GET_CHIBI_ERROR_LOG = 13;
		private static byte FUNCTION_SET_CHIBI_FREQUENCY = 14;
		private static byte FUNCTION_GET_CHIBI_FREQUENCY = 15;
		private static byte FUNCTION_SET_CHIBI_CHANNEL = 16;
		private static byte FUNCTION_GET_CHIBI_CHANNEL = 17;
		private static byte FUNCTION_IS_RS485_PRESENT = 18;
		private static byte FUNCTION_SET_RS485_ADDRESS = 19;
		private static byte FUNCTION_GET_RS485_ADDRESS = 20;
		private static byte FUNCTION_SET_RS485_SLAVE_ADDRESS = 21;
		private static byte FUNCTION_GET_RS485_SLAVE_ADDRESS = 22;
		private static byte FUNCTION_GET_RS485_ERROR_LOG = 23;
		private static byte FUNCTION_SET_RS485_CONFIGURATION = 24;
		private static byte FUNCTION_GET_RS485_CONFIGURATION = 25;
		private static byte FUNCTION_IS_WIFI_PRESENT = 26;
		private static byte FUNCTION_SET_WIFI_CONFIGURATION = 27;
		private static byte FUNCTION_GET_WIFI_CONFIGURATION = 28;
		private static byte FUNCTION_SET_WIFI_ENCRYPTION = 29;
		private static byte FUNCTION_GET_WIFI_ENCRYPTION = 30;
		private static byte FUNCTION_GET_WIFI_STATUS = 31;
		private static byte FUNCTION_REFRESH_WIFI_STATUS = 32;
		private static byte FUNCTION_SET_WIFI_CERTIFICATE = 33;
		private static byte FUNCTION_GET_WIFI_CERTIFICATE = 34;
		private static byte FUNCTION_SET_WIFI_POWER_MODE = 35;
		private static byte FUNCTION_GET_WIFI_POWER_MODE = 36;
		private static byte FUNCTION_GET_WIFI_BUFFER_INFO = 37;
		private static byte FUNCTION_SET_WIFI_REGULATORY_DOMAIN = 38;
		private static byte FUNCTION_GET_WIFI_REGULATORY_DOMAIN = 39;
		private static byte FUNCTION_GET_USB_VOLTAGE = 40;
		private static byte FUNCTION_RESET = 243;
		private static byte FUNCTION_GET_CHIP_TEMPERATURE = 242;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickMaster(string uid) : base(uid) 
		{
			this.expectedName = "Master Brick";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 3;
			this.bindingVersion[2] = 2;

		}

		/// <summary>
		///  Returns the stack voltage in mV. The stack voltage is the
		///  voltage that is supplied via the stack, i.e. it is given by a 
		///  Step-Down or Step-Up Power Supply.
		/// </summary>
		public ushort GetStackVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_STACK_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_STACK_VOLTAGE, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Returns the stack current in mA. The stack current is the
		///  current that is drawn via the stack, i.e. it is given by a
		///  Step-Down or Step-Up Power Supply.
		/// </summary>
		public ushort GetStackCurrent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_STACK_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_STACK_CURRENT, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Writes the extension type to the EEPROM of a specified extension. 
		///  The extension is either 0 or 1 (0 is the on the bottom, 1 is the on on top, 
		///  if only one extension is present use 0).
		///  
		///  Possible extension types:
		///  
		///  <code>
		///   "Type", "Description"
		///  
		///   "1",    "Chibi"
		///   "2",    "RS485"
		///   "3",    "WIFI"
		///  </code>
		///  
		///  The extension type is already set when bought and it can be set with the 
		///  Brick Viewer, it is unlikely that you need this function.
		///  
		///  The value will be saved in the EEPROM of the Chibi Extension, it does not
		///  have to be set on every startup.
		/// </summary>
		public void SetExtensionType(byte extension, uint exttype)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_EXTENSION_TYPE, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(extension, 4, data_);
			LEConverter.To(exttype, 5, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the extension type for a given extension as set by 
		///  <see cref="Tinkerforge.BrickMaster.SetExtensionType"/>.
		/// </summary>
		public uint GetExtensionType(byte extension)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_EXTENSION_TYPE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(extension, 4, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_EXTENSION_TYPE, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Returns *true* if a Chibi Extension is available to be used by the Master.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public bool IsChibiPresent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_IS_CHIBI_PRESENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_IS_CHIBI_PRESENT, out response);

			return LEConverter.BoolFrom(4, response);
		}

		/// <summary>
		///  Sets the address (1-255) belonging to the Chibi Extension.
		///  
		///  It is possible to set the address with the Brick Viewer and it will be 
		///  saved in the EEPROM of the Chibi Extension, it does not
		///  have to be set on every startup.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public void SetChibiAddress(byte address)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CHIBI_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(address, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the address as set by <see cref="Tinkerforge.BrickMaster.SetChibiAddress"/>.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public byte GetChibiAddress()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIBI_ADDRESS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIBI_ADDRESS, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Sets the address (1-255) of the Chibi Master. This address is used if the
		///  Chibi Extension is used as slave (i.e. it does not have a USB connection).
		///  
		///  It is possible to set the address with the Brick Viewer and it will be 
		///  saved in the EEPROM of the Chibi Extension, it does not
		///  have to be set on every startup.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public void SetChibiMasterAddress(byte address)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CHIBI_MASTER_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(address, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the address as set by <see cref="Tinkerforge.BrickMaster.SetChibiMasterAddress"/>.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public byte GetChibiMasterAddress()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIBI_MASTER_ADDRESS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIBI_MASTER_ADDRESS, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Sets up to 254 slave addresses. Valid addresses are in range 1-255.
		///  The address numeration (via num parameter) has to be used
		///  ascending from 0. For example: If you use the Chibi Extension in Master mode
		///  (i.e. the stack has an USB connection) and you want to talk to three other
		///  Chibi stacks with the slave addresses 17, 23, and 42, you should call with "(0, 17),
		///  (1, 23) and (2, 42)".
		///  
		///  It is possible to set the addresses with the Brick Viewer and it will be 
		///  saved in the EEPROM of the Chibi Extension, they don't
		///  have to be set on every startup.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public void SetChibiSlaveAddress(byte num, byte address)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CHIBI_SLAVE_ADDRESS, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(num, 4, data_);
			LEConverter.To(address, 5, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the slave address for a given num as set by 
		///  <see cref="Tinkerforge.BrickMaster.SetChibiSlaveAddress"/>.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public byte GetChibiSlaveAddress(byte num)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIBI_SLAVE_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(num, 4, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIBI_SLAVE_ADDRESS, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Returns the signal strength in dBm. The signal strength updates every time a
		///  packet is received.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public byte GetChibiSignalStrength()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Returns underrun, CRC error, no ACK and overflow error counts of the Chibi
		///  communication. If these errors start rising, it is likely that either the
		///  distance between two Chibi stacks is becoming too big or there are
		///  interferences.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public void GetChibiErrorLog(out ushort underrun, out ushort crcError, out ushort noAck, out ushort overflow)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIBI_ERROR_LOG, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIBI_ERROR_LOG, out response);

			underrun = LEConverter.UShortFrom(4, response);
			crcError = LEConverter.UShortFrom(6, response);
			noAck = LEConverter.UShortFrom(8, response);
			overflow = LEConverter.UShortFrom(10, response);
		}

		/// <summary>
		///  Sets the Chibi frequency range for the Chibi Extension. Possible values are:
		///  
		///  <code>
		///   "Type", "Description"
		///  
		///   "0",    "OQPSK 868Mhz (Europe)"
		///   "1",    "OQPSK 915Mhz (US)"
		///   "2",    "OQPSK 780Mhz (China)"
		///   "3",    "BPSK40 915Mhz"
		///  </code>
		///  
		///  It is possible to set the frequency with the Brick Viewer and it will be 
		///  saved in the EEPROM of the Chibi Extension, it does not
		///  have to be set on every startup.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public void SetChibiFrequency(byte frequency)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CHIBI_FREQUENCY, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(frequency, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the frequency value as set by <see cref="Tinkerforge.BrickMaster.SetChibiFrequency"/>.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public byte GetChibiFrequency()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIBI_FREQUENCY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIBI_FREQUENCY, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Sets the channel used by the Chibi Extension. Possible channels are
		///  different for different frequencies:
		///  
		///  <code>
		///   "Frequency",             "Possible Channels"
		///  
		///   "OQPSK 868Mhz (Europe)", "0"
		///   "OQPSK 915Mhz (US)",     "1, 2, 3, 4, 5, 6, 7, 8, 9, 10"
		///   "OQPSK 780Mhz (China)",  "0, 1, 2, 3"
		///   "BPSK40 915Mhz",         "1, 2, 3, 4, 5, 6, 7, 8, 9, 10"
		///  </code>
		///  
		///  It is possible to set the channel with the Brick Viewer and it will be 
		///  saved in the EEPROM of the Chibi Extension, it does not
		///  have to be set on every startup.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public void SetChibiChannel(byte channel)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CHIBI_CHANNEL, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(channel, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the channel as set by <see cref="Tinkerforge.BrickMaster.SetChibiChannel"/>.
		///  
		///  .. versionadded:: 1.1.0~(Firmware)
		/// </summary>
		public byte GetChibiChannel()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIBI_CHANNEL, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIBI_CHANNEL, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Returns *true* if a RS485 Extension is available to be used by the Master.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public bool IsRS485Present()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_IS_RS485_PRESENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_IS_RS485_PRESENT, out response);

			return LEConverter.BoolFrom(4, response);
		}

		/// <summary>
		///  Sets the address (1-255) belonging to the RS485 Extension.
		///  
		///  Set to 0 if the RS485 Extension should be the RS485 Master (i.e.
		///  connected to a PC via USB).
		///  
		///  It is possible to set the address with the Brick Viewer and it will be 
		///  saved in the EEPROM of the RS485 Extension, it does not
		///  have to be set on every startup.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public void SetRS485Address(byte address)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_RS485_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(address, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the address as set by <see cref="Tinkerforge.BrickMaster.SetRS485Address"/>.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public byte GetRS485Address()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_RS485_ADDRESS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_RS485_ADDRESS, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Sets up to 255 slave addresses. Valid addresses are in range 1-255.
		///  The address numeration (via num parameter) has to be used
		///  ascending from 0. For example: If you use the RS485 Extension in Master mode
		///  (i.e. the stack has an USB connection) and you want to talk to three other
		///  RS485 stacks with the IDs 17, 23, and 42, you should call with "(0, 17),
		///  (1, 23) and (2, 42)".
		///  
		///  It is possible to set the addresses with the Brick Viewer and it will be 
		///  saved in the EEPROM of the RS485 Extension, they don't
		///  have to be set on every startup.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public void SetRS485SlaveAddress(byte num, byte address)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_RS485_SLAVE_ADDRESS, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(num, 4, data_);
			LEConverter.To(address, 5, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the slave address for a given num as set by 
		///  <see cref="Tinkerforge.BrickMaster.SetRS485SlaveAddress"/>.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public byte GetRS485SlaveAddress(byte num)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_RS485_SLAVE_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(num, 4, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_RS485_SLAVE_ADDRESS, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Returns CRC error counts of the RS485 communication.
		///  If this counter starts rising, it is likely that the distance
		///  between the RS485 nodes is too big or there is some kind of
		///  interference.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public ushort GetRS485ErrorLog()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_RS485_ERROR_LOG, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_RS485_ERROR_LOG, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Sets the configuration of the RS485 Extension. Speed is given in baud. The
		///  Master Brick will try to match the given baud rate as exactly as possible.
		///  The maximum recommended baud rate is 2000000 (2Mbit/s).
		///  Possible values for parity are 'n' (none), 'e' (even) and 'o' (odd).
		///  Possible values for stop bits are 1 and 2.
		///  
		///  If your RS485 is unstable (lost messages etc), the first thing you should
		///  try is to decrease the speed. On very large bus (e.g. 1km), you probably
		///  should use a value in the range of 100khz.
		///  
		///  The values are stored in the EEPROM and only applied on startup. That means
		///  you have to restart the Master Brick after configuration.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public void SetRS485Configuration(uint speed, char parity, byte stopbits)
		{
			byte[] data_ = new byte[10];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_RS485_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)10, 2, data_);
			LEConverter.To(speed, 4, data_);
			LEConverter.To(parity, 8, data_);
			LEConverter.To(stopbits, 9, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickMaster.SetRS485Configuration"/>.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public void GetRS485Configuration(out uint speed, out char parity, out byte stopbits)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_RS485_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_RS485_CONFIGURATION, out response);

			speed = LEConverter.UIntFrom(4, response);
			parity = LEConverter.CharFrom(8, response);
			stopbits = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Returns *true* if a WIFI Extension is available to be used by the Master.
		///  
		///  .. versionadded:: 1.2.0~(Firmware)
		/// </summary>
		public bool IsWifiPresent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_IS_WIFI_PRESENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_IS_WIFI_PRESENT, out response);

			return LEConverter.BoolFrom(4, response);
		}

		/// <summary>
		///  Sets the configuration of the WIFI Extension. The ssid can have a max length
		///  of 32 characters, the connection is either 0 for DHCP or 1 for static IP.
		///  
		///  If you set connection to 1, you have to supply ip, subnet mask and gateway
		///  as an array of size 4 (first element of the array is the least significant
		///  byte of the address). If connection is set to 0 ip, subnet mask and gateway
		///  are ignored, you can set them to 0.
		///  
		///  The last parameter is the port that your program will connect to. The
		///  default port, that is used by brickd, is 4223.
		///  
		///  The values are stored in the EEPROM and only applied on startup. That means
		///  you have to restart the Master Brick after configuration.
		///  
		///  It is recommended to use the Brick Viewer to set the WIFI configuration.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void SetWifiConfiguration(string ssid, byte connection, byte[] ip, byte[] subnetMask, byte[] gateway, ushort port)
		{
			byte[] data_ = new byte[51];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_WIFI_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)51, 2, data_);
			LEConverter.To(ssid, 4, 32, data_);
			LEConverter.To(connection, 36, data_);
			LEConverter.To(ip, 37, 4, data_);
			LEConverter.To(subnetMask, 41, 4, data_);
			LEConverter.To(gateway, 45, 4, data_);
			LEConverter.To(port, 49, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickMaster.SetWifiConfiguration"/>.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void GetWifiConfiguration(out string ssid, out byte connection, out byte[] ip, out byte[] subnetMask, out byte[] gateway, out ushort port)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_WIFI_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_WIFI_CONFIGURATION, out response);

			ssid = LEConverter.StringFrom(4, response, 32);
			connection = LEConverter.ByteFrom(36, response);
			ip = LEConverter.ByteArrayFrom(37, response, 4);
			subnetMask = LEConverter.ByteArrayFrom(41, response, 4);
			gateway = LEConverter.ByteArrayFrom(45, response, 4);
			port = LEConverter.UShortFrom(49, response);
		}

		/// <summary>
		///  Sets the encryption of the WIFI Extension. The first parameter is the
		///  type of the encryption. Possible values are:
		///  
		///  <code>
		///   "Value", "Description"
		///  
		///   "0", "WPA/WPA2"
		///   "1", "WPA Enterprise (EAP-FAST, EAP-TLS, EAP-TTLS, PEAP)"
		///   "2", "WEP"
		///   "3", "No Encryption"
		///  </code>
		///  
		///  The key has a max length of 50 characters and is used if encryption
		///  is set to 0 or 2 (WPA or WEP). Otherwise the value is ignored.
		///  For WEP it is possible to set the key index (1-4). If you don't know your
		///  key index, it is likely 1.
		///  
		///  If you choose WPA Enterprise as encryption, you have to set eap options and
		///  the length of the certificates (for other encryption types these paramters
		///  are ignored). The certificate length are given in byte and the certificates
		///  themself can be set with  <see cref="Tinkerforge.BrickMaster.SetWifiCertificate"/>. Eap options consist of 
		///  the outer authentication (bits 1-2), inner authentication (bit 3) and 
		///  certificate type (bits 4-5):
		///  
		///  <code>
		///   "Option", "Bits", "Description"
		///  
		///   "outer auth", "1-2", "0=EAP-FAST, 1=EAP-TLS, 2=EAP-TTLS, 3=EAP-PEAP"
		///   "inner auth", "3", "0=EAP-MSCHAP, 1=EAP-GTC"
		///   "cert type", "4-5", "0=CA Certificate, 1=Client Certificate, 2=Private Key"
		///  </code>
		///  
		///  Example for EAP-TTLS + EAP-GTC + Private Key: option = 2 | (1 &lt;&lt; 2) | (2 &lt;&lt; 3).
		///  
		///  The values are stored in the EEPROM and only applied on startup. That means
		///  you have to restart the Master Brick after configuration.
		///  
		///  It is recommended to use the Brick Viewer to set the WIFI encryption.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void SetWifiEncryption(byte encryption, string key, byte keyIndex, byte eapOptions, ushort caCertificateLength, ushort clientCertificateLength, ushort privateKeyLength)
		{
			byte[] data_ = new byte[63];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_WIFI_ENCRYPTION, 1, data_);
			LEConverter.To((ushort)63, 2, data_);
			LEConverter.To(encryption, 4, data_);
			LEConverter.To(key, 5, 50, data_);
			LEConverter.To(keyIndex, 55, data_);
			LEConverter.To(eapOptions, 56, data_);
			LEConverter.To(caCertificateLength, 57, data_);
			LEConverter.To(clientCertificateLength, 59, data_);
			LEConverter.To(privateKeyLength, 61, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the encryption as set by <see cref="Tinkerforge.BrickMaster.SetWifiEncryption"/>.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void GetWifiEncryption(out byte encryption, out string key, out byte keyIndex, out byte eapOptions, out ushort caCertificateLength, out ushort clientCertificateLength, out ushort privateKeyLength)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_WIFI_ENCRYPTION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_WIFI_ENCRYPTION, out response);

			encryption = LEConverter.ByteFrom(4, response);
			key = LEConverter.StringFrom(5, response, 50);
			keyIndex = LEConverter.ByteFrom(55, response);
			eapOptions = LEConverter.ByteFrom(56, response);
			caCertificateLength = LEConverter.UShortFrom(57, response);
			clientCertificateLength = LEConverter.UShortFrom(59, response);
			privateKeyLength = LEConverter.UShortFrom(61, response);
		}

		/// <summary>
		///  Returns the status of the WIFI Extension. The state is updated automatically,
		///  all of the other parameters are updated on startup and every time
		///  <see cref="Tinkerforge.BrickMaster.RefreshWifiStatus"/> is called.
		///  
		///  Possible states are:
		///  
		///  <code>
		///   "State", "Description"
		///  
		///   "0", "Disassociated"
		///   "1", "Associated"
		///   "2", "Associating"
		///   "3", "Error"
		///   "255", "Not initialized yet"
		///  </code>
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void GetWifiStatus(out byte[] macAddress, out byte[] bssid, out byte channel, out short rssi, out byte[] ip, out byte[] subnetMask, out byte[] gateway, out uint rxCount, out uint txCount, out byte state)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_WIFI_STATUS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_WIFI_STATUS, out response);

			macAddress = LEConverter.ByteArrayFrom(4, response, 6);
			bssid = LEConverter.ByteArrayFrom(10, response, 6);
			channel = LEConverter.ByteFrom(16, response);
			rssi = LEConverter.ShortFrom(17, response);
			ip = LEConverter.ByteArrayFrom(19, response, 4);
			subnetMask = LEConverter.ByteArrayFrom(23, response, 4);
			gateway = LEConverter.ByteArrayFrom(27, response, 4);
			rxCount = LEConverter.UIntFrom(31, response);
			txCount = LEConverter.UIntFrom(35, response);
			state = LEConverter.ByteFrom(39, response);
		}

		/// <summary>
		///  Refreshes the WIFI status (see <see cref="Tinkerforge.BrickMaster.GetWifiStatus"/>). To read the status
		///  of the WIFI module, the Master Brick has to change from data mode to
		///  command mode and back. This transaction and the readout itself is
		///  unfortunately time consuming. This means, that it might take some ms
		///  until the stack with attached WIFI Extensions reacts again after this
		///  function is called.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void RefreshWifiStatus()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_REFRESH_WIFI_STATUS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  This function is used to set the certificate as well as password and username
		///  for WPA Enterprise. To set the username use index 0xFFFF,
		///  to set the password use index 0xFFFE. The max length of username and 
		///  password is 32.
		///  
		///  The certificate is written in chunks of size 32 and the index is used as
		///  the index of the chunk. The data length should nearly always be 32. Only
		///  the last chunk can have a length that is not equal to 32.
		///  
		///  The starting index of the CA Certificate is 0, of the Client Certificate
		///  10000 and for the Private Key 20000. Maximum sizes are 1312, 1312 and
		///  4320 byte respectively.
		///  
		///  The values are stored in the EEPROM and only applied on startup. That means
		///  you have to restart the Master Brick after uploading the certificate.
		///  
		///  It is recommended to use the Brick Viewer to set the certificate, username
		///  and password.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void SetWifiCertificate(ushort index, byte[] data, byte dataLength)
		{
			byte[] data_ = new byte[39];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_WIFI_CERTIFICATE, 1, data_);
			LEConverter.To((ushort)39, 2, data_);
			LEConverter.To(index, 4, data_);
			LEConverter.To(data, 6, 32, data_);
			LEConverter.To(dataLength, 38, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the certificate for a given index as set by <see cref="Tinkerforge.BrickMaster.SetWifiCertificate"/>.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void GetWifiCertificate(ushort index, out byte[] data, out byte dataLength)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_WIFI_CERTIFICATE, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(index, 4, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_WIFI_CERTIFICATE, out response);

			data = LEConverter.ByteArrayFrom(4, response, 32);
			dataLength = LEConverter.ByteFrom(36, response);
		}

		/// <summary>
		///  Sets the power mode of the WIFI Extension. Possible modes are:
		///  
		///  <code>
		///   "Mode", "Description"
		///  
		///   "0", "Full Speed (high power consumption, high throughput)"
		///   "1", "Low Power (low power consumption, low throughput)"
		///  </code>
		///  
		///  The default value is 0 (Full Speed).
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public void SetWifiPowerMode(byte mode)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_WIFI_POWER_MODE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(mode, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the power mode as set by <see cref="Tinkerforge.BrickMaster.SetWifiPowerMode"/>.
		///  
		///  .. versionadded:: 1.3.0~(Firmware)
		/// </summary>
		public byte GetWifiPowerMode()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_WIFI_POWER_MODE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_WIFI_POWER_MODE, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Returns informations about the WIFI receive buffer. The WIFI
		///  receive buffer has a max size of 1500 byte and if data is transfered
		///  too fast, it might overflow.
		///  
		///  The return values are the number of overflows, the low watermark 
		///  (i.e. the smallest number of bytes that were free in the buffer) and
		///  the bytes that are currently used.
		///  
		///  You should always try to keep the buffer empty, otherwise you will
		///  have a permanent latency. A good rule of thumb is, that you can transfer
		///  1000 messages per second without problems.
		///  
		///  Try to not send more then 50 messages at a time without any kind of
		///  break between them. 
		///  
		///  .. versionadded:: 1.3.2~(Firmware)
		/// </summary>
		public void GetWifiBufferInfo(out uint overflow, out ushort lowWatermark, out ushort used)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_WIFI_BUFFER_INFO, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_WIFI_BUFFER_INFO, out response);

			overflow = LEConverter.UIntFrom(4, response);
			lowWatermark = LEConverter.UShortFrom(8, response);
			used = LEConverter.UShortFrom(10, response);
		}

		/// <summary>
		///  Sets the regulatory domain of the WIFI Extension. Possible modes are:
		///  
		///  <code>
		///   "Mode", "Description"
		///  
		///   "0", "FCC: Channel 1-11 (N/S America, Australia, New Zealand)"
		///   "1", "ETSI: Channel 1-13 (Europe, Middle East, Africa)"
		///   "2", "TELEC: Channel 1-14 (Japan)"
		///  </code>
		///  
		///  The default value is 1 (ETSI).
		///  
		///  .. versionadded:: 1.3.4~(Firmware)
		/// </summary>
		public void SetWifiRegulatoryDomain(byte domain)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_WIFI_REGULATORY_DOMAIN, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(domain, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the regulatory domain as set by <see cref="Tinkerforge.BrickMaster.SetWifiRegulatoryDomain"/>.
		///  
		///  .. versionadded:: 1.3.4~(Firmware)
		/// </summary>
		public byte GetWifiRegulatoryDomain()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_WIFI_REGULATORY_DOMAIN, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_WIFI_REGULATORY_DOMAIN, out response);

			return LEConverter.ByteFrom(4, response);
		}

		/// <summary>
		///  Returns the USB voltage in mV.
		/// </summary>
		public ushort GetUSBVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_USB_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_USB_VOLTAGE, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Calling this function will reset the Brick. Calling this function
		///  on a Brick inside of a stack will reset the whole stack.
		///  
		///  After a reset you have to create new device objects,
		///  calling functions on the existing ones will result in
		///  undefined behavior!
		///  
		///  .. versionadded:: 1.2.1~(Firmware)
		/// </summary>
		public void Reset()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_RESET, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the temperature in °C/10 as measured inside the microcontroller. The
		///  value returned is not the ambient temperature!
		///  
		///  The temperature is only proportional to the real temperature and it has an
		///  accuracy of +-15%. Practically it is only useful as an indicator for
		///  temperature changes.
		///  
		///  .. versionadded:: 1.2.1~(Firmware)
		/// </summary>
		public short GetChipTemperature()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIP_TEMPERATURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIP_TEMPERATURE, out response);

			return LEConverter.ShortFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetStackVoltage(out ushort voltage)
		{
			voltage = GetStackVoltage();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetStackCurrent(out ushort current)
		{
			current = GetStackCurrent();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetExtensionType(byte extension, out uint exttype)
		{
			exttype = GetExtensionType(extension);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void IsChibiPresent(out bool present)
		{
			present = IsChibiPresent();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChibiAddress(out byte address)
		{
			address = GetChibiAddress();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChibiMasterAddress(out byte address)
		{
			address = GetChibiMasterAddress();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChibiSlaveAddress(byte num, out byte address)
		{
			address = GetChibiSlaveAddress(num);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChibiSignalStrength(out byte signalStrength)
		{
			signalStrength = GetChibiSignalStrength();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChibiFrequency(out byte frequency)
		{
			frequency = GetChibiFrequency();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChibiChannel(out byte channel)
		{
			channel = GetChibiChannel();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void IsRS485Present(out bool present)
		{
			present = IsRS485Present();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetRS485Address(out byte address)
		{
			address = GetRS485Address();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetRS485SlaveAddress(byte num, out byte address)
		{
			address = GetRS485SlaveAddress(num);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetRS485ErrorLog(out ushort crcError)
		{
			crcError = GetRS485ErrorLog();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void IsWifiPresent(out bool present)
		{
			present = IsWifiPresent();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetWifiPowerMode(out byte mode)
		{
			mode = GetWifiPowerMode();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetWifiRegulatoryDomain(out byte mode)
		{
			mode = GetWifiRegulatoryDomain();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetUSBVoltage(out ushort voltage)
		{
			voltage = GetUSBVoltage();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChipTemperature(out short temperature)
		{
			temperature = GetChipTemperature();
		}
	}
}
