/* ***********************************************************
 * This file was automatically generated on 2012-10-12.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for sensing air pressure and altitude changes
	/// </summary>
	public class BrickletBarometer : Device 
	{
		private static byte FUNCTION_GET_AIR_PRESSURE = 1;
		private static byte FUNCTION_GET_ALTITUDE = 2;
		private static byte FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD = 3;
		private static byte FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD = 4;
		private static byte FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD = 5;
		private static byte FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD = 6;
		private static byte FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD = 7;
		private static byte FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD = 8;
		private static byte FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD = 9;
		private static byte FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD = 10;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 11;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 12;
		private static byte FUNCTION_SET_REFERENCE_AIR_PRESSURE = 13;
		private static byte FUNCTION_GET_CHIP_TEMPERATURE = 14;
		private static byte CALLBACK_AIR_PRESSURE = 15;
		private static byte CALLBACK_ALTITUDE = 16;
		private static byte CALLBACK_AIR_PRESSURE_REACHED = 17;
		private static byte CALLBACK_ALTITUDE_REACHED = 18;
		private static byte FUNCTION_GET_REFERENCE_AIR_PRESSURE = 19;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletBarometer.SetAirPressureCallbackPeriod"/>. The parameter is the air pressure of the
		///  air pressure sensor.
		///  
		///  <see cref="Tinkerforge.BrickletBarometer.AirPressure"/> is only triggered if the air pressure has changed since the
		///  last triggering.
		/// </summary>
		public delegate void AirPressure(int airPressure);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletBarometer.SetAltitudeCallbackPeriod"/>. The parameter is the altitude of the
		///  air pressure sensor.
		///  
		///  <see cref="Tinkerforge.BrickletBarometer.Altitude"/> is only triggered if the altitude has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Altitude(int altitude);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletBarometer.SetAirPressureCallbackThreshold"/> is reached.
		///  The parameter is the air pressure of the air pressure sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletBarometer.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void AirPressureReached(int airPressure);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletBarometer.SetAltitudeCallbackThreshold"/> is reached.
		///  The parameter is the altitude of the air pressure sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletBarometer.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void AltitudeReached(int altitude);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletBarometer(string uid) : base(uid) 
		{
			this.expectedName = "Barometer Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 1;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_AIR_PRESSURE] = new MessageCallback(CallbackAirPressure);
			messageCallbacks[CALLBACK_ALTITUDE] = new MessageCallback(CallbackAltitude);
			messageCallbacks[CALLBACK_AIR_PRESSURE_REACHED] = new MessageCallback(CallbackAirPressureReached);
			messageCallbacks[CALLBACK_ALTITUDE_REACHED] = new MessageCallback(CallbackAltitudeReached);
		}

		/// <summary>
		///  Returns the air pressure of the air pressure sensor. The value
		///  has a range of 10000 to 1200000 and is given in mbar/1000, i.e. a value
		///  of 1001092 means that an air pressure of 1001.092 mbar is measured.
		///  
		///  If you want to get the air pressure periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletBarometer.AirPressure"/> and set the period with
		///  <see cref="Tinkerforge.BrickletBarometer.SetAirPressureCallbackPeriod"/>.
		/// </summary>
		public int GetAirPressure()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_AIR_PRESSURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_AIR_PRESSURE, out response);

			return LEConverter.IntFrom(4, response);
		}

		/// <summary>
		///  Returns the relative altitude of the air pressure sensor. The value is given in
		///  cm and is caluclated based on the difference between the current air pressure
		///  and the reference air pressure that can be set with <see cref="Tinkerforge.BrickletBarometer.SetReferenceAirPressure"/>.
		///  
		///  If you want to get the altitude periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletBarometer.Altitude"/> and set the period with
		///  <see cref="Tinkerforge.BrickletBarometer.SetAltitudeCallbackPeriod"/>.
		/// </summary>
		public int GetAltitude()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ALTITUDE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ALTITUDE, out response);

			return LEConverter.IntFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletBarometer.AirPressure"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletBarometer.AirPressure"/> is only triggered if the air pressure has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAirPressureCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletBarometer.SetAirPressureCallbackPeriod"/>.
		/// </summary>
		public uint GetAirPressureCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletBarometer.Altitude"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletBarometer.Altitude"/> is only triggered if the altitude has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAltitudeCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletBarometer.SetAltitudeCallbackPeriod"/>.
		/// </summary>
		public uint GetAltitudeCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletBarometer.AirPressureReached"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the air pressure is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the air pressure is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the air pressure is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the air pressure is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetAirPressureCallbackThreshold(char option, int min, int max)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 9, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletBarometer.SetAirPressureCallbackThreshold"/>.
		/// </summary>
		public void GetAirPressureCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.IntFrom(5, response);
			max = LEConverter.IntFrom(9, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletBarometer.AltitudeReached"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the altitude is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the altitude is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the altitude is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the altitude is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetAltitudeCallbackThreshold(char option, int min, int max)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 9, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletBarometer.SetAltitudeCallbackThreshold"/>.
		/// </summary>
		public void GetAltitudeCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.IntFrom(5, response);
			max = LEConverter.IntFrom(9, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///   <see cref="Tinkerforge.BrickletBarometer.AirPressureReached"/>, <see cref="Tinkerforge.BrickletBarometer.AltitudeReached"/>
		///  
		///  are triggered, if the thresholds
		///  
		///   <see cref="Tinkerforge.BrickletBarometer.SetAirPressureCallbackThreshold"/>, <see cref="Tinkerforge.BrickletBarometer.SetAltitudeCallbackThreshold"/>
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletBarometer.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the reference air pressure in mbar/1000 for the altitude calculation.
		///  Setting the reference to the current air pressure results in a calculated
		///  altitude of 0cm. Passing 0 is a shortcut for passing the current air pressure as
		///  reference.
		///  
		///  Well known reference values are the Q codes
		///  `QNH &lt;http://en.wikipedia.org/wiki/QNH&gt;`__ and
		///  `QFE &lt;http://en.wikipedia.org/wiki/Mean_sea_level_pressure#Mean_sea_level_pressure&gt;`__
		///  used in aviation.
		///  
		///  The default value is 1013.25mbar.
		///  
		///  .. versionadded:: 1.1.0~(Plugin)
		/// </summary>
		public void SetReferenceAirPressure(int airPressure)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_REFERENCE_AIR_PRESSURE, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(airPressure, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the temperature of the air pressure sensor. The value
		///  has a range of -4000 to 8500 and is given in °C/100, i.e. a value
		///  of 2007 means that a temperature of 20.07 °C is measured.
		///  
		///  This temperature is used internally for temperature compensation of the air
		///  pressure measurement. It is not as accurate as the temperature measured by the
		///  :ref:`temperature_bricklet` or the :ref:`temperature_ir_bricklet`.
		/// </summary>
		public short GetChipTemperature()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CHIP_TEMPERATURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CHIP_TEMPERATURE, out response);

			return LEConverter.ShortFrom(4, response);
		}

		/// <summary>
		///  Returns the reference air pressure as set by <see cref="Tinkerforge.BrickletBarometer.SetReferenceAirPressure"/>.
		///  
		///  .. versionadded:: 1.1.0~(Plugin)
		/// </summary>
		public int GetReferenceAirPressure()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_REFERENCE_AIR_PRESSURE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_REFERENCE_AIR_PRESSURE, out response);

			return LEConverter.IntFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAirPressure(out int airPressure)
		{
			airPressure = GetAirPressure();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAltitude(out int altitude)
		{
			altitude = GetAltitude();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAirPressureCallbackPeriod(out uint period)
		{
			period = GetAirPressureCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAltitudeCallbackPeriod(out uint period)
		{
			period = GetAltitudeCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetChipTemperature(out short temperature)
		{
			temperature = GetChipTemperature();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetReferenceAirPressure(out int airPressure)
		{
			airPressure = GetReferenceAirPressure();
		}

		internal int CallbackAirPressure(byte[] data_)
		{
			int airPressure = LEConverter.IntFrom(4, data_);

			((AirPressure)callbacks[CALLBACK_AIR_PRESSURE])(airPressure);
			return 8;
		}

		internal int CallbackAltitude(byte[] data_)
		{
			int altitude = LEConverter.IntFrom(4, data_);

			((Altitude)callbacks[CALLBACK_ALTITUDE])(altitude);
			return 8;
		}

		internal int CallbackAirPressureReached(byte[] data_)
		{
			int airPressure = LEConverter.IntFrom(4, data_);

			((AirPressureReached)callbacks[CALLBACK_AIR_PRESSURE_REACHED])(airPressure);
			return 8;
		}

		internal int CallbackAltitudeReached(byte[] data_)
		{
			int altitude = LEConverter.IntFrom(4, data_);

			((AltitudeReached)callbacks[CALLBACK_ALTITUDE_REACHED])(altitude);
			return 8;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(AirPressure))
			{
				callbacks[CALLBACK_AIR_PRESSURE] = d;
			}
			else if(d.GetType() == typeof(Altitude))
			{
				callbacks[CALLBACK_ALTITUDE] = d;
			}
			else if(d.GetType() == typeof(AirPressureReached))
			{
				callbacks[CALLBACK_AIR_PRESSURE_REACHED] = d;
			}
			else if(d.GetType() == typeof(AltitudeReached))
			{
				callbacks[CALLBACK_ALTITUDE_REACHED] = d;
			}
		}
	}
}
