/* ***********************************************************
 * This file was automatically generated on 2012-10-12.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for sensing Linear Potentiometer input
	/// </summary>
	public class BrickletLinearPoti : Device 
	{
		private static byte FUNCTION_GET_POSITION = 1;
		private static byte FUNCTION_GET_ANALOG_VALUE = 2;
		private static byte FUNCTION_SET_POSITION_CALLBACK_PERIOD = 3;
		private static byte FUNCTION_GET_POSITION_CALLBACK_PERIOD = 4;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;
		private static byte FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = 7;
		private static byte FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = 8;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 11;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 12;
		private static byte CALLBACK_POSITION = 13;
		private static byte CALLBACK_ANALOG_VALUE = 14;
		private static byte CALLBACK_POSITION_REACHED = 15;
		private static byte CALLBACK_ANALOG_VALUE_REACHED = 16;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletLinearPoti.SetPositionCallbackPeriod"/>. The parameter is the position of the
		///  Linear Potentiometer.
		///  
		///  <see cref="Tinkerforge.BrickletLinearPoti.Position"/> is only triggered if the position has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Position(ushort position);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletLinearPoti.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value of the
		///  Linear Potentiometer.
		///  
		///  <see cref="Tinkerforge.BrickletLinearPoti.AnalogValue"/> is only triggered if the position has changed since the
		///  last triggering.
		/// </summary>
		public delegate void AnalogValue(ushort value);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletLinearPoti.SetPositionCallbackThreshold"/> is reached.
		///  The parameter is the position of the Linear Potentiometer.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletLinearPoti.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void PositionReached(ushort position);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletLinearPoti.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the Linear Potentiometer.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletLinearPoti.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void AnalogValueReached(ushort value);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletLinearPoti(string uid) : base(uid) 
		{
			this.expectedName = "Linear Poti Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_POSITION] = new MessageCallback(CallbackPosition);
			messageCallbacks[CALLBACK_ANALOG_VALUE] = new MessageCallback(CallbackAnalogValue);
			messageCallbacks[CALLBACK_POSITION_REACHED] = new MessageCallback(CallbackPositionReached);
			messageCallbacks[CALLBACK_ANALOG_VALUE_REACHED] = new MessageCallback(CallbackAnalogValueReached);
		}

		/// <summary>
		///  Returns the position of the Linear Potentiometer. The value is  
		///  between 0 (slider down) and 100 (slider up).
		///  
		///  If you want to get the position periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletLinearPoti.Position"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletLinearPoti.SetPositionCallbackPeriod"/>.
		/// </summary>
		public ushort GetPosition()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POSITION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_POSITION, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Returns the value as read by a 12-bit analog-to-digital converter.
		///  The value is between 0 and 4095.
		///  
		///  <note>
		///   The value returned by <see cref="Tinkerforge.BrickletLinearPoti.GetPosition"/> is averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletLinearPoti.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletLinearPoti.GetAnalogValue"/> is,
		///   if you need the full resolution of the analog-to-digital converter.
		///  </note>
		///  
		///  If you want the analog value periodically, it is recommended to use the 
		///  callback <see cref="Tinkerforge.BrickletLinearPoti.AnalogValue"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletLinearPoti.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public ushort GetAnalogValue()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletLinearPoti.Position"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletLinearPoti.Position"/> is only triggered if the position has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetPositionCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_POSITION_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletLinearPoti.SetPositionCallbackPeriod"/>.
		/// </summary>
		public uint GetPositionCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POSITION_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_POSITION_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletLinearPoti.AnalogValue"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletLinearPoti.AnalogValue"/> is only triggered if the analog value has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletLinearPoti.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public uint GetAnalogValueCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletLinearPoti.PositionReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the position is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the position is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the position is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the position is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetPositionCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_POSITION_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletLinearPoti.SetPositionCallbackThreshold"/>.
		/// </summary>
		public void GetPositionCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.ShortFrom(5, response);
			max = LEConverter.ShortFrom(7, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletLinearPoti.AnalogValueReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, ushort min, ushort max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletLinearPoti.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out ushort min, out ushort max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.UShortFrom(5, response);
			max = LEConverter.UShortFrom(7, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///   <see cref="Tinkerforge.BrickletLinearPoti.PositionReached"/>, <see cref="Tinkerforge.BrickletLinearPoti.AnalogValueReached"/>
		///  
		///  are triggered, if the thresholds
		///  
		///   <see cref="Tinkerforge.BrickletLinearPoti.SetPositionCallbackThreshold"/>, <see cref="Tinkerforge.BrickletLinearPoti.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletLinearPoti.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetPosition(out ushort position)
		{
			position = GetPosition();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValue(out ushort value)
		{
			value = GetAnalogValue();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetPositionCallbackPeriod(out uint period)
		{
			period = GetPositionCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValueCallbackPeriod(out uint period)
		{
			period = GetAnalogValueCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		internal int CallbackPosition(byte[] data_)
		{
			ushort position = LEConverter.UShortFrom(4, data_);

			((Position)callbacks[CALLBACK_POSITION])(position);
			return 6;
		}

		internal int CallbackAnalogValue(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValue)callbacks[CALLBACK_ANALOG_VALUE])(value);
			return 6;
		}

		internal int CallbackPositionReached(byte[] data_)
		{
			ushort position = LEConverter.UShortFrom(4, data_);

			((PositionReached)callbacks[CALLBACK_POSITION_REACHED])(position);
			return 6;
		}

		internal int CallbackAnalogValueReached(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValueReached)callbacks[CALLBACK_ANALOG_VALUE_REACHED])(value);
			return 6;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Position))
			{
				callbacks[CALLBACK_POSITION] = d;
			}
			else if(d.GetType() == typeof(AnalogValue))
			{
				callbacks[CALLBACK_ANALOG_VALUE] = d;
			}
			else if(d.GetType() == typeof(PositionReached))
			{
				callbacks[CALLBACK_POSITION_REACHED] = d;
			}
			else if(d.GetType() == typeof(AnalogValueReached))
			{
				callbacks[CALLBACK_ANALOG_VALUE_REACHED] = d;
			}
		}
	}
}
